-- name: \\#2525ff\\Nova Stars \\#ffffff\\v1.1
-- description: \\#2525ff\\Nova Stars\n\n\\#efefff\\You find the game too \\#00ff00\\easy \\#efefff\\or not \n\\#ff5050\\challenging \\#efefff\\enough? Well this is the mod for you! This adds new stars that\n\are very \\#ee0000\\hard \\#efefff\\to get and requires very\n\high-skill!\n \n\(You must have collected all 120 stars before getting these) \n \n \n\Rules for the stars are very simple...\n\- You are only allowed to use your own skills\n\n\- NO CHEATS! Whatsoever!\n \n \n\Creator: \\#1cff55\\Key's \\#09990e\\Artworks\n\\#efefff\\Coder: \\#ff92af\\Blocky\n\\#efefff\\Contibutors: \\#ffffff\\Colby\\#ffa5e6\\Ra\\#34c2f8\\yz!\\#efefff\\, \\#ffbab5\\Sunk\\#efefff\\, \\#ffffff\\6b\\#efefff\\, \n\\#402ac9\\ShwetunlinYT\n\n\\#efefff\\There's also a secret collectible too! Hope you can find it! It's very\n\\#008800\\Squishy\\#efefff\\

gGlobalSyncTable.novaStarsEnabled = false
local level = np[0].currLevelNum

local function spawn_star_and_challenge(star, model, behavior)
    spawn_sync_object(behavior, model, star.pos.x, star.pos.y, star.pos.z, function (o)
        o.oBehParams = star.starID << 24
        o.oFaceAngleRoll = 0
        o.oFaceAnglePitch = 0
        set_challenge(0, star.challenge)

        o.oModel = star.forceModel or gNovaStarModels[currHack][currMoveset].normal

        if star.initFunc then
            star.initFunc(o)
        end
    end)
end

local function spawn_red_coins(redsPos)
    for _, green in pairs(redsPos) do
        spawn_sync_object(id_bhvMSRedCoin, E_MODEL_GREEN_COIN, green.x, green.y, green.z, function () end)
    end
end

local function spawn_lamps(lampPos)
    for _, lamp in pairs(lampPos) do
        spawn_non_sync_object(id_bhvLamp, E_MODEL_LAMP, lamp.x, lamp.y, lamp.z, function () end)
    end
end

function handle_star_spawn(star, m)

    if star.lampPos then
        spawn_lamps(star.lampPos)
    end

    local customModelInfo = gNovaStarModels[currHack][currMoveset]

    if star.redsPos then
        spawn_star_and_challenge(star, customModelInfo.transparent, id_bhvMSRedCoinStarSpawner)
        spawn_red_coins(star.redsPos)
    else
        spawn_star_and_challenge(star, customModelInfo.normal, id_bhvMSStar)
    end

    if is_challenge_active(m, CHALLENGE_RISING_LAVA) and not obj_get_first_with_behavior_id(id_bhvLava) then
        spawn_sync_object(id_bhvLava, E_MODEL_LAVA, 0, m.pos.y - star.lava.startBelowY, 0, function (o)
            o.oBehParams2ndByte = star.lava.speed
        end)
    elseif is_challenge_active(m, CHALLENGE_QUICKSAND_PIT) and not obj_get_first_with_behavior_id(id_bhvQuicksand) then
        spawn_sync_object(id_bhvQuicksand, E_MODEL_QUICKSAND, 0, m.pos.y - star.quicksand.belowY * 2, 0, function (o)
            o.oBehParams = star.quicksand.belowY
        end)
    end
end

local function sync_valid()
    local npl = gNetworkPlayers[0]
    local currLevel = npl.currLevelNum
    local area = npl.currAreaIndex
    local act = npl.currActNum

    if not gNovaStarData[currHack] then
        return
    elseif not gNovaStarData[currHack][currMoveset] then
        return
    end

    local novaStarInfo = gNovaStarData[currHack][currMoveset][currLevel]
    local pipeInfo = gNovaPipes[currHack][currMoveset][currLevel]

    if hud_is_hidden() and np[0].currLevelNum ~= LEVEL_ACT_SELECT then
        hud_show()
    end

    if not gGlobalSyncTable.novaStarsEnabled then return end

    local m = gMarioStates[0]

    if level ~= currLevel then
        reset_challenges(0)
        level = currLevel
    end

    if pipeInfo and np[0].currActNum < 7 then
        for i, pipe in pairs(pipeInfo) do
            if area == pipe.pipeArea then
                spawn_non_sync_object(id_bhvNovaPipe, E_MODEL_BITS_WARP_PIPE, pipe.pos.x, pipe.pos.y, pipe.pos.z, function (o)
                    o.oBehParams = (o.oBehParams & 0xFFFF00) | pipe.level
                    o.oBehParams2ndByte = pipe.course
                    o.globalPlayerIndex = gNetworkPlayers[0].globalIndex
                end)
            end
        end
    end

    if novaStarInfo then
        for i, star in pairs(novaStarInfo) do
            if area == star.area and ((star.starID + 7) * (network_global_index_from_local(0) + 1)) == act then
                handle_star_spawn(star, m)
                gLevelValues.coinsRequiredForCoinStar = star.coinStar or 0
                gLevelValues.disableActs = true 
            end
        end
    else
        ps[0].novaAct = 0
        gLevelValues.coinsRequiredForCoinStar = preNovaStarCoinStarReq
        gLevelValues.disableActs = preNovaStarDisableActs
    end

    if is_challenge_active(m, CHALLENGE_PVP_RACE) and not search_for_obj(id_bhvRacer, npl.globalIndex) then
        spawn_non_sync_object(id_bhvRacer, E_MODEL_COSMIC_CLONE, 0, 0, 0, function(obj)
            obj.oOwner = npl.globalIndex
            obj.globalPlayerIndex = npl.globalIndex
            obj.oAction = 0
        end)
    end

    if is_challenge_active(m, CHALLENGE_COSMIC_CLONE) and not search_for_obj(id_bhvCosmicClone, npl.globalIndex) then
        cosmicClonePath = {}
        for i = 1, cosmicClonesNum do
            spawn_non_sync_object(id_bhvCosmicClone, E_MODEL_COSMIC_CLONE, 0, -5000, 0, function(obj)
                obj.oOwner = npl.globalIndex
                obj.globalPlayerIndex = npl.globalIndex
                obj.oDelayCountdown = (delay * 0.5) * i
            end)
        end
    end

    update_lighting(m)
end

local function mario_update(m)
    if m.playerIndex ~= 0 then return end

    if m.numStars >= 120 then
        gGlobalSyncTable.novaStarsEnabled = true
    end
    if not gGlobalSyncTable.novaStarsEnabled then return end

    local lava = obj_get_first_with_behavior_id(id_bhvLava)

    if m.controller.buttonDown & A_BUTTON ~= 0 and m.controller.buttonDown & D_JPAD ~= 0 and debug then
        set_mario_action(m, ACT_EDITED_DEBUG_FREE_MOVE, 0)
    end

    if lava and m.pos.y < lava.oPosY - 10 then -- sometimes the lava's collision will be overshadowed by another floor, this is the "fix"
        set_mario_action(m, ACT_LAVA_BOOST, 0)
        m.hurtCounter = 12
    end

    if is_challenge_active(m, CHALLENGE_CAPLESS) then
        if m.flags | (MARIO_WING_CAP | MARIO_VANISH_CAP | MARIO_METAL_CAP) ~= 0 then
            m.flags = m.flags & ~(MARIO_WING_CAP | MARIO_VANISH_CAP | MARIO_METAL_CAP)
            stop_cap_music()
        end
    end
    if is_challenge_active(m, CHALLENGE_DAREDEVIL) then
        if m.health >= 0x110 then
            m.health = 0x110
        end
    end
    if is_challenge_active(m, CHALLENGE_TOXIC_GAS) then
        m.health = m.health - 2
    end

    if is_challenge_active(m, CHALLENGE_ACID_RAIN) then
        if not m.ceil and m.action ~= ACT_IN_CANNON then
            m.health = m.health - 8
        end
    end

    if is_challenge_active(m, CHALLENGE_GROUNDLESS) then

        if not ps[0].hasTouchedGround then
            if m.pos.y == find_floor_height(m.pos.x, m.pos.y, m.pos.z) then
                set_mario_action(m, ACT_LONG_JUMP, 0)
                m.forwardVel = 45
                m.faceAngle.y = m.intendedYaw
                ps[0].hasTouchedGround = true
            end
        elseif m.pos.y == find_floor_height(m.pos.x, m.pos.y, m.pos.z) then
            for_each_object_with_behavior(id_bhvSpawnedMSStar, obj_mark_for_deletion)
            for_each_object_with_behavior(id_bhvMSStar, obj_mark_for_deletion)
            for_each_object_with_behavior(id_bhvMSRedCoinStarSpawner, obj_mark_for_deletion)
            play_sound(SOUND_MENU_CAMERA_BUZZ, gGlobalSoundSource)
            reset_challenges(0)
        end
    end

    if is_challenge_active(m, CHALLENGE_TIMED) then
        increment_challenge_timer(m.playerIndex, 1)
        local o = obj_get_first_with_behavior_id(id_bhvMSStar) or obj_get_first_with_behavior_id(id_bhvMSRedCoinStarSpawner)
        hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_TIMER)
        hud_set_value(HUD_DISPLAY_TIMER, (o and o.oChallengeTimerMax or 65535) - get_challenge_timer(0))
    end

    if is_challenge_active(m, CHALLENGE_ABC) then
        if m.controller.buttonPressed & A_BUTTON ~= 0 then
            ps[m.playerIndex].APressCount = ps[m.playerIndex].APressCount + 1
        end
    end

    if is_challenge_active(m, CHALLENGE_NO_BLJS) then
        if m.forwardVel < -45 then
            m.forwardVel = -45
        end
    end

    local lamp = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvLamp)

    if lamp then
        local dist = dist_between_objects(lamp, m.marioObj)

        local factor = clampf(1 - (dist / MAX_LIGHT_DISTANCE), 0, 1)

        local r = math.floor(lightR * factor)
        local g = math.floor(lightG * factor)
        local b = math.floor(lightB * factor)

        set_lighting_color(0, r)
        set_lighting_color(1, g)
        set_lighting_color(2, b)

        set_vertex_color(0, r)
        set_vertex_color(1, g)
        set_vertex_color(2, b)
    end

    -- Special
    if is_challenge_active(m, CHALLENGE_QUICKSAND_PIT) and gNetworkPlayers[0].currLevelNum == LEVEL_TTC and currHack == "vanilla" then
        set_ttc_speed_setting(TTC_SPEED_FAST)
    end
end

ACT_EDITED_DEBUG_FREE_MOVE = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_STATIONARY | ACT_FLAG_AIR | ACT_FLAG_METAL_WATER)

function act_debug_free_move(m)

    local gPlayer1Controller = gMarioStates[0].controller

    -- integer immediates, generates convert instructions for some reason

    local speed = gPlayer1Controller.buttonDown & B_BUTTON ~= 0 and 2 or 4

    m.faceAngle.y = m.intendedYaw
    m.health = 0x880

    set_mario_animation(m, MARIO_ANIM_A_POSE)
    local pos = {x = m.pos.x, y = m.pos.y, z = m.pos.z}

    if gPlayer1Controller.buttonDown & A_BUTTON ~= 0 then
        pos.y = pos.y + 16.0 * speed
    end
    if gPlayer1Controller.buttonDown & Z_TRIG ~= 0 then
        pos.y = pos.y - 16.0 * speed
    end
    if gPlayer1Controller.buttonPressed & Y_BUTTON ~= 0 then
        set_mario_action(m, ACT_FREEFALL, 0)
    end

    if m.intendedMag > 0 then
        pos.x = pos.x + 26.0 * speed * sins(m.intendedYaw)
        pos.z = pos.z + 26.0 * speed * coss(m.intendedYaw)
    end

    local surf = m.floor.type
    local floorHeight = find_floor_height(pos.x, pos.y, pos.z)
    if surf ~= nil then
        if pos.y < floorHeight then
            pos.y = floorHeight
        end
      vec3f_copy(m.pos, pos)
    end

    vec3f_copy(m.marioObj.header.gfx.pos, m.pos)
    vec3s_set(m.marioObj.header.gfx.angle, 0, m.faceAngle.y, 0)

    return false
end

hook_mario_action(ACT_EDITED_DEBUG_FREE_MOVE, act_debug_free_move, 0)

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SYNC_VALID, sync_valid)